package demo.bluewindow;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.EventQueue;
import java.text.ParseException;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.UIManager;

import de.javasoft.plaf.synthetica.SyntheticaBlackEyeLookAndFeel;

public class MyBlueWindow extends JFrame
{ 
  //on Windows Java 6u14 or above is required - on MAC Java 1.5 or above 
  public static void main(String[] args) throws Exception
  {
    UIManager.setLookAndFeel(new SyntheticaBlackEyeLookAndFeel(){
      @Override
      protected void loadXMLConfig(String fileName) throws ParseException
      {
        super.loadXMLConfig(fileName);
        super.loadXMLConfig("/demo/bluewindow/blueWindow.xml");
      }
    });
    EventQueue.invokeLater(new Runnable()
    {
      public void run()
      {        
        new MyBlueWindow();
      }
    });
  }
  
  public MyBlueWindow()
  {
    //add some window content
    add(new JColorChooser());
    
    JDialog d = new JDialog(this);
    initDialog(d);

    setTitle("Custom Window Decoration Example");
    setDefaultCloseOperation(EXIT_ON_CLOSE);
    setSize(600, 400);
    setLocationRelativeTo(null);
    setVisible(true);
    d.setVisible(true);
  }

  private void initDialog(JDialog d)
  {
    d.setTitle("Blue Window Dialog");
    d.setName("BlueWindow");
    JTextArea textArea = new JTextArea("Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.");
    textArea.setLineWrap(true);
    textArea.setEditable(false);
    textArea.setFocusable(false);
    textArea.setFont(textArea.getFont().deriveFont(14f));
    textArea.putClientProperty("Synthetica.opaque", false);
    JScrollPane scroller = new JScrollPane(textArea);
    d.add(scroller);
    
    JPanel p = new JPanel();
    p.setOpaque(false);
    p.setLayout(new BoxLayout(p, BoxLayout.LINE_AXIS));    
    p.add(Box.createHorizontalGlue());
    p.add(createBlueButton("OK"));
    p.add(createBlueButton("Cancel"));
    d.add(p, BorderLayout.SOUTH);
    d.setSize(400,250);
    d.setLocationRelativeTo(null);
  }
  
  private JButton createBlueButton(String text)
  {    
    JButton b = new JButton(text){
      @Override
      public Dimension getPreferredSize()
      {
        return new Dimension(Math.max(80, super.getMinimumSize().width) , super.getPreferredSize().height);
      }
    };
    //modify button color
    //b.putClientProperty("Synthetica.background", Color.BLUE);
    //since Synthetica V2.9.2 you can set the background color direct
    b.setBackground(Color.BLUE);
    return b;
  }
}
